<template>
  <Dialog :title="dialogTitle" v-model="dialogVisible">
    <el-form
      ref="formRef"
      :model="formData"
      :rules="formRules"
      label-width="100px"
      v-loading="formLoading"
    >
      <el-form-item label="部门id" prop="deptId">
        <el-input v-model="formData.deptId" placeholder="请输入部门id" />
      </el-form-item>
      <el-form-item label="物料领用单编号" prop="requisitionNumber">
        <el-input v-model="formData.requisitionNumber" placeholder="请输入物料领用单编号" />
      </el-form-item>
      <el-form-item label="物料领用单名称" prop="name">
        <el-input v-model="formData.name" placeholder="请输入物料领用单名称" />
      </el-form-item>
      <el-form-item label="领用用途(1维修  2保养 3其它)" prop="type">
        <el-select v-model="formData.type" placeholder="请选择领用用途(1维修  2保养 3其它)">
          <el-option label="请选择字典生成" value="" />
        </el-select>
      </el-form-item>
      <el-form-item label="领用人姓名" prop="responsiblePerson">
        <el-input v-model="formData.responsiblePerson" placeholder="请输入领用人姓名" />
      </el-form-item>
      <el-form-item label="物料总费用" prop="cost">
        <el-input v-model="formData.cost" placeholder="请输入物料总费用" />
      </el-form-item>
      <el-form-item label="领用结果(1待执行 2已执行)" prop="result">
        <el-input v-model="formData.result" placeholder="请输入领用结果(1待执行 2已执行)" />
      </el-form-item>
      <el-form-item label="其他费用" prop="otherCost">
        <el-input v-model="formData.otherCost" placeholder="请输入其他费用" />
      </el-form-item>
      <el-form-item label="人工费用" prop="laborCost">
        <el-input v-model="formData.laborCost" placeholder="请输入人工费用" />
      </el-form-item>
      <el-form-item label="领用日期" prop="requisitionTime">
        <el-date-picker
          v-model="formData.requisitionTime"
          type="date"
          value-format="x"
          placeholder="选择领用日期"
        />
      </el-form-item>
      <el-form-item label="领用原因" prop="reason">
        <el-input v-model="formData.reason" placeholder="请输入领用原因" />
      </el-form-item>
      <el-form-item label="备注（如特殊要求、紧急程度）" prop="remark">
        <el-input v-model="formData.remark" placeholder="请输入备注（如特殊要求、紧急程度）" />
      </el-form-item>
      <el-form-item label="状态 0=未出库 1=已出库 2=已关闭" prop="status">
        <el-radio-group v-model="formData.status">
          <el-radio value="1">请选择字典生成</el-radio>
        </el-radio-group>
      </el-form-item>
      <el-form-item label="流程实例id" prop="processInstanceId">
        <el-input v-model="formData.processInstanceId" placeholder="请输入流程实例id" />
      </el-form-item>
      <el-form-item label="审批状态 未提交、审批中、审批通过、审批不通过、已取消" prop="auditStatus">
        <el-radio-group v-model="formData.auditStatus">
          <el-radio value="1">请选择字典生成</el-radio>
        </el-radio-group>
      </el-form-item>
    </el-form>
    <template #footer>
      <el-button @click="submitForm" type="primary" :disabled="formLoading">确 定</el-button>
      <el-button @click="dialogVisible = false">取 消</el-button>
    </template>
  </Dialog>
</template>
<script setup lang="ts">
import { IotMaterialRequisitionApi, IotMaterialRequisitionVO } from '@/api/pms/iotmaterialrequisition'

/** 物料领用 表单 */
defineOptions({ name: 'IotMaterialRequisitionForm' })

const { t } = useI18n() // 国际化
const message = useMessage() // 消息弹窗

const dialogVisible = ref(false) // 弹窗的是否展示
const dialogTitle = ref('') // 弹窗的标题
const formLoading = ref(false) // 表单的加载中：1）修改时的数据加载；2）提交的按钮禁用
const formType = ref('') // 表单的类型：create - 新增；update - 修改
const formData = ref({
  id: undefined,
  deptId: undefined,
  requisitionNumber: undefined,
  name: undefined,
  type: undefined,
  responsiblePerson: undefined,
  cost: undefined,
  result: undefined,
  otherCost: undefined,
  laborCost: undefined,
  requisitionTime: undefined,
  reason: undefined,
  remark: undefined,
  status: undefined,
  processInstanceId: undefined,
  auditStatus: undefined,
})
const formRules = reactive({
})
const formRef = ref() // 表单 Ref

/** 打开弹窗 */
const open = async (type: string, id?: number) => {
  dialogVisible.value = true
  dialogTitle.value = t('action.' + type)
  formType.value = type
  resetForm()
  // 修改时，设置数据
  if (id) {
    formLoading.value = true
    try {
      formData.value = await IotMaterialRequisitionApi.getIotMaterialRequisition(id)
    } finally {
      formLoading.value = false
    }
  }
}
defineExpose({ open }) // 提供 open 方法，用于打开弹窗

/** 提交表单 */
const emit = defineEmits(['success']) // 定义 success 事件，用于操作成功后的回调
const submitForm = async () => {
  // 校验表单
  await formRef.value.validate()
  // 提交请求
  formLoading.value = true
  try {
    const data = formData.value as unknown as IotMaterialRequisitionVO
    if (formType.value === 'create') {
      await IotMaterialRequisitionApi.createIotMaterialRequisition(data)
      message.success(t('common.createSuccess'))
    } else {
      await IotMaterialRequisitionApi.updateIotMaterialRequisition(data)
      message.success(t('common.updateSuccess'))
    }
    dialogVisible.value = false
    // 发送操作成功的事件
    emit('success')
  } finally {
    formLoading.value = false
  }
}

/** 重置表单 */
const resetForm = () => {
  formData.value = {
    id: undefined,
    deptId: undefined,
    requisitionNumber: undefined,
    name: undefined,
    type: undefined,
    responsiblePerson: undefined,
    cost: undefined,
    result: undefined,
    otherCost: undefined,
    laborCost: undefined,
    requisitionTime: undefined,
    reason: undefined,
    remark: undefined,
    status: undefined,
    processInstanceId: undefined,
    auditStatus: undefined,
  }
  formRef.value?.resetFields()
}
</script>